#ifndef _XewVideoP_h
#define _XewVideoP_h
/*
** Copyright 1992 by Markku Savela and
**	Technical Research Centre of Finland
**
** The author maybe contacted via:
**
**    Mail:	Markku Savela
**		Technical Research Centre of Finland
**		Telecommunications Laboratory
**		Otakaari 7 B, P.O. Box 34
**		SF-02151 ESPOO
**		Finland
**
**    Phone:	+358 0 456 6509
**    Email:	savela@tel.vtt.fi
*/

#include <stdio.h>
#include <X11/Xew/BasicP.h>
#include <X11/Xew/AnimationP.h>
#include <X11/Xew/Video.h>

typedef struct _XeVideoClass
    {
	int makes_compiler_happy;	/* not used */
    } XeVideoClassPart;

typedef struct _XeVideoClassRec
    {
	CoreClassPart	core_class;
	XeBasicClassPart basic_class;
	XeAnimationClassPart animation_class;
	XeVideoClassPart video_class;
    } XeVideoClassRec;

typedef struct
    {
	/* resources */
	int		brightness;
	int		contrast;
        Boolean         useShm;
	/* private state */
    } XeVideoPart;

typedef struct _XeVideoRec
    {
	CorePart	core;
	XeBasicPart	basic;
	XeAnimationPart	animation;
	XeVideoPart	video;
    } XeVideoRec;

/* Class pointer */
extern XeVideoClassRec xeVideoClassRec;

#endif
